#!/usr/bin/env node

var download = require('download-git-repo');
var program = require('commander');
var chalk = require('chalk');
var path = require('path');
var file = require('../lib/file');

/**
 * Usage.
 */

program
    .usage('<module-name>');

/**
 * Help.
 */

program.on('--help', function () {
    console.log('  Examples:');
    console.log();
    console.log(chalk.green('    # create a new project with an official template'));
    console.log('    $ bnc init webpack my-project');
    console.log();
    console.log(chalk.green('    # create a new project straight from a github template'));
    console.log('    $ bnc init username/repo my-project');
    console.log();
});

program.parse(process.argv);
if (program.args.length < 1) {
    program.help();
}

var type = program.args[0];
file.replace(type);
var projectName = program.args[1];
var name = process.cwd();

process.on('exit', function () {
    console.log();
});

if(projectName) {
    download('BaiduBnc/bnc-demo', name, function (err) {
        if(err) {
            console.log(err);
        } else {
            console.log(type + ' created success!');
        }
    });
}