#!/usr/bin/env node

var http = require('http');

var req = http.get('http://bnc.nuomi.com/bnc/getAbilityList', function (res) {
    var statusCode = res.statusCode;

    var error;
    if(statusCode !== 200) {
        error = new Error('请求失败。\n' + '状态码: ' + statusCode);
    }
    if(error) {
        console.error('请求遇到问题: ' + error.message);
        res.resume();
        return;
    }

    res.setEncoding('utf8');
    var rawData = '';
    res.on('data', function (chunk) {
        rawData += chunk;
    });
    res.on('end', function () {
        try {
            var parsedData = JSON.parse(rawData);
            console.log(parsedData.data.join('\n'));
        } catch (e) {
            console.error(e.message);
        }
    })
});

req.on('error', function (e) {
    console.error('请求遇到问题: ' + e.message);
});