
var fs = require('fs');
var path = require('path');
var chalk = require('chalk');

var blackList = ['\.DS_Store', '\.git', '\.idea', 'node_module'];

var File = {

    data: [],

    readDir: function (root) {
        var self = this;
        var files = fs.readdirSync(root);
        files.map(function (value) {
            var filename = path.join(root, value);
            var status = fs.statSync(filename);
            if(status.isDirectory()) {
                self.readDir(filename);
            } else {
                self.filter(filename);
            }
        });
    },

    filter: function (filename) {
        var self = this;
        var reg = new RegExp(blackList.join('|'), 'g');
        if(reg.test(filename)) {
            return;
        }
        self.data.push(filename);
    },

    replace: function (from, to) {
        var reg = new RegExp(from, 'g');

        this.data.map(function (value) {
            fs.readFile(value, {encoding: 'utf-8'}, function (err, data) {
                if(reg.test(data)) {
                    var tmp = data.replace(reg, to);
                    console.log(chalk.blue('replace: ' + value));
                    fs.writeFile(value, tmp);
                }
            })
        });
    },

    read: function (key) {
        var filename;
        this.data.map(function (value) {
            var reg = new RegExp(key, 'ig');
            if(reg.test(value)) {
                filename = value;
            }
        });
        if(filename) {
            return fs.readFileSync(filename, {encoding: 'utf-8'});
        } else {
            return '';
        }
    },

    write: function (filename, content) {
        fs.writeFile(filename, content, 'utf8')
    },

    watch: function (cb) {
        fs.watch(process.cwd(), {recursive: true}, function (eventType, filename) {
            var reg = new RegExp(blackList.join('|'), 'g');
            if(reg.test(filename)) {
                return;
            }

            if(!/entry.js/.test(filename)) {
                cb && cb();
            }
        });
    }
};

module.exports = {
    replace: function (to) {
        var base = process.cwd();
        File.readDir(base);
        File.replace('bncDemo', to);
    },
    read: function (key) {
        var base = process.cwd();
        File.readDir(base);
        return File.read(key);
    },
    write: function (filename, content) {
        File.write(filename, content);
    },
    watch: function (cb) {
        File.watch(cb);
    }
};